﻿using HarmonyLib;
using HMLLibrary;
using Steamworks;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Reflection.Emit;
using UnityEngine;
using UnityEngine.UI;
using System.Globalization;
using Debug = UnityEngine.Debug;
using Object = UnityEngine.Object;


namespace MiscCheats
{
    public class Main : Mod
    {
        public static Main instance;
        Harmony harmony;
        public bool returnArmor = false;
        public float puzzleTime = 1;
        public float enginePower = 1;
        public bool hardRespawn = false;
        bool _rc = false;
        public bool refineComb
        {
            get => _rc;
            set
            {
                if (_rc == value)
                    return;
                _rc = value;
                var i = value ? ItemManager.GetItemByIndex(294) : null;
                foreach (var e in Resources.FindObjectsOfTypeAll<Placeable_BiofuelExtractor>())
                {
                    var l = Traverse.Create(e.honeyTank).Field("acceptableTypes").GetValue<List<Item_Base>>();
                    if (value)
                        l.Add(i);
                    else
                        l.RemoveAll(x => !x || x.UniqueIndex == 294);
                }
            }
        }
        public float lootTime = 1;
        public float seagullAware = 1;
        public float metalTreasure = 1;
        public bool freeVending = false;
        public bool sniperRange = false;
        public string zoomKey = null;
        public int zoomFOV = 30;
        public float autoOff = -1;
        public bool fishingEqual = false;
        public bool freeCrafting = false;
        public int consoleLines = -1;
        public float fishingWait = 1;
        public float fishingWindow = 1;
        public float itemLooting = 1;
        public bool keepInventory = false;
        public bool antennaAnywhere = false;
        public bool recieverAnywhere = false;
        public bool noDurability = false;
        public bool noPower = false;
        public float batteryMax = 1;
        public float equipmentMax = 1;
        public float toolMax = 1;
        public float foodMax = 1;
        public float collectorMax = 1;
        public bool recycleMetal = false;
        public float sprinklerRadius = 1;
        public float sprinklerDistance = 1;
        public void Start()
        {
            instance = this;
            (harmony = new Harmony("com.aidanamite.LotsOLittleMods")).PatchAll();
            Log("Mod has been loaded!");
        }

        public void OnModUnload()
        {
            harmony.UnpatchAll(harmony.Id);
            Log("Mod has been unloaded!");
        }

        public bool ExtraSettingsAPI_Loaded = false;
        void ExtraSettingsAPI_Load() => ExtraSettingsAPI_SettingsClose();
        void ExtraSettingsAPI_SettingsClose()
        {
            returnArmor = ExtraSettingsAPI_GetCheckboxState("returnArmor");
            puzzleTime = ExtraSettingsAPI_GetInputValue("puzzleTime").ParseFloat();
            enginePower = ExtraSettingsAPI_GetInputValue("enginePower").ParseFloat();
            hardRespawn = ExtraSettingsAPI_GetCheckboxState("hardRespawn");
            refineComb = ExtraSettingsAPI_GetCheckboxState("refineComb");
            lootTime = ExtraSettingsAPI_GetInputValue("lootTime").ParseFloat();
            seagullAware = ExtraSettingsAPI_GetInputValue("seagullAware").ParseFloat();
            metalTreasure = ExtraSettingsAPI_GetInputValue("metalTreasure").ParseFloat();
            freeVending = ExtraSettingsAPI_GetCheckboxState("freeVending");
            sniperRange = ExtraSettingsAPI_GetCheckboxState("sniperRange");
            autoOff = ExtraSettingsAPI_GetInputValue("autoOff").ParseFloat(-1);
            fishingEqual = ExtraSettingsAPI_GetCheckboxState("fishingEqual");
            freeCrafting = ExtraSettingsAPI_GetCheckboxState("freeCrafting");
            consoleLines = ExtraSettingsAPI_GetInputValue("consoleLines").ParseInt(-1);
            if (consoleLines >= 0)
            {
                var l = Traverse.Create(typeof(RConsole)).Field("logs").GetValue<List<GameObject>>();
                while (l.Count > consoleLines && l.Count > 0)
                {
                    Destroy(l[0]);
                    l.RemoveAt(0);
                }
            }
            zoomFOV = ExtraSettingsAPI_GetInputValue("zoomFOV").ParseInt(-1);
            zoomKey = ExtraSettingsAPI_GetKeybindName("zoomKey");
            fishingWait = ExtraSettingsAPI_GetInputValue("fishingWait").ParseFloat();
            fishingWindow = ExtraSettingsAPI_GetInputValue("fishingWindow").ParseFloat();
            itemLooting = ExtraSettingsAPI_GetInputValue("itemLooting").ParseFloat();
            keepInventory = ExtraSettingsAPI_GetCheckboxState("keepInventory");
            recieverAnywhere = ExtraSettingsAPI_GetCheckboxState("recieverAnywhere");
            antennaAnywhere = ExtraSettingsAPI_GetCheckboxState("antennaAnywhere");
            batteryMax = ExtraSettingsAPI_GetInputValue("batteryMax").ParseFloat();
            equipmentMax = ExtraSettingsAPI_GetInputValue("equipmentMax").ParseFloat();
            toolMax = ExtraSettingsAPI_GetInputValue("toolMax").ParseFloat();
            foodMax = ExtraSettingsAPI_GetInputValue("foodMax").ParseFloat();
            collectorMax = ExtraSettingsAPI_GetInputValue("collectorMax").ParseFloat();
            recycleMetal = ExtraSettingsAPI_GetCheckboxState("recycleMetal");
            sprinklerRadius = ExtraSettingsAPI_GetInputValue("sprinklerRadius").ParseFloat();
            sprinklerDistance = ExtraSettingsAPI_GetInputValue("sprinklerDistance").ParseFloat();
        }

        void ExtraSettingsAPI_ButtonPress(string SettingName)
        {
            if (SettingName == "reset")
                ExtraSettingsAPI_ResetAllSettings();
        }

        bool ExtraSettingsAPI_GetCheckboxState(string SettingName) => new bool();
        string ExtraSettingsAPI_GetInputValue(string SettingName) => "".ToString();
        string ExtraSettingsAPI_GetKeybindName(string SettingName) => "".ToString();
        void ExtraSettingsAPI_ResetAllSettings() { }
    }

    [HarmonyPatch(typeof(RemovePlaceables), "ReturnItemsFromBlock")]
    static class Patch_ReturnItemsFromBlock
    {
        static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions)
        {
            var code = instructions.ToList();
            code.InsertRange(
                code.FindIndex(x => x.opcode == OpCodes.Callvirt && (x.operand as MethodInfo).Name == "get_NewCost") + 1,
                new[] {
                    new CodeInstruction(OpCodes.Ldarg_0),
                    new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(Patch_ReturnItemsFromBlock), nameof(ModifyReturnCost)))
                });
            code.InsertRange(
                code.FindIndex(x => x.opcode == OpCodes.Stloc_0) + 1,
                new[] {
                    new CodeInstruction(OpCodes.Ldarg_0),
                    new CodeInstruction(OpCodes.Ldarg_1),
                    new CodeInstruction(OpCodes.Ldarg_2),
                    new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(Patch_ReturnItemsFromBlock), nameof(ReturnArmor)))
                });
            return code;
        }
        static CostMultiple[] ModifyReturnCost(CostMultiple[] original, Block block)
        {
            if (Main.instance.freeCrafting)
                return new CostMultiple[0];
            if (Main.instance.returnArmor && Patch_UpgradingBlock.ReturnArmorFromUpgrade(block.ObjectIndex) && block.Reinforced && !(block.buildableItem?.settings_buildable?.GetBlockPrefab(0)?.Reinforced ?? false))
                return original.AddRangeToArray(ItemManager.GetItemByIndex(96).settings_recipe.NewCost);
            return original;
        }
        static void ReturnArmor(Block block, Network_Player player, bool giveItems)
        {
            if (giveItems && player && Main.instance.returnArmor && Patch_UpgradingBlock.ReturnArmorFromUpgrade(block.ObjectIndex) && !Main.instance.freeCrafting && block.Reinforced && !(block.buildableItem?.settings_buildable?.GetBlockPrefab(0)?.Reinforced ?? false))
                foreach (var c in ItemManager.GetItemByIndex(96).settings_recipe.NewCost)
                    if (c?.items?.Length > 0 && c.amount > 0)
                        player.Inventory.AddItem(new ItemInstance(c.items[0], c.amount, c.items[0].MaxUses));
        }
    }
    [HarmonyPatch(typeof(BlockCreator), "UpgradeBlock")]
    class Patch_UpgradingBlock
    {
        static Dictionary<uint, bool> upgrades = new Dictionary<uint, bool>();
        static void Prefix(Item_Base newBlockItem, Block oldBlock) => upgrades[oldBlock.ObjectIndex] = newBlockItem?.settings_buildable?.GetBlockPrefab(0)?.Reinforced ?? false;

        public static bool ReturnArmorFromUpgrade(uint ObjectIndex) {
            if (upgrades.TryGetValue(ObjectIndex, out var r))
            {
                upgrades.Remove(ObjectIndex);
                return r;
            }
            return true;
        }
    }

    [HarmonyPatch(typeof(CostMultiple), "HasEnoughInInventory")]
    static class Patch_HasEnoughForCostMultiple
    {
        static void Postfix(Inventory inventory, ref bool __result)
        {
            if (Main.instance.freeCrafting && inventory is PlayerInventory)
                __result = true;
        }
    }

    [HarmonyPatch(typeof(Inventory), "RemoveCostMultiple")]
    static class Patch_RemoveCostFromInventory
    {
        static bool Prefix(Inventory __instance, CostMultiple[] costMultiple, bool manipulateCostAmount)
        {
            if (Main.instance.freeCrafting && __instance is PlayerInventory)
            {
                if (manipulateCostAmount)
                    foreach (var c in costMultiple)
                        c.amount = 0;
                return false;
            }
            return true;
        }
    }

    [HarmonyPatch(typeof(CostCollection), "MeetsRequirements")]
    static class Patch_CostCollectionComplete
    {
        static void Postfix(ref bool __result)
        {
            if (Main.instance.freeCrafting)
                __result = true;
        }
    }

    [HarmonyPatch(typeof(FishingBaitHandler), "GetRandomItemFromCurrentBaitPool")]
    static class Patch_Fishing
    {
        public static bool calling = false;
        static void Prefix() => calling = Main.instance.fishingEqual;
        static void POstfix() => calling = false;
    }

    [HarmonyPatch(typeof(SO_RandomDropper), "GetRandomItem")]
    static class Patch_GetRandomDropperItem
    {
        static void Prefix(SO_RandomDropper __instance, ref RandomItem[] __state)
        {
            if (Patch_Fishing.calling)
            {
                __state = __instance.randomizer.items;
                __instance.randomizer.items = new RandomItem[__state.Length];
                for (int i = 0; i < __state.Length; i++)
                {
                    __instance.randomizer.items[i] = new RandomItem();
                    __instance.randomizer.items[i].CopyFieldsOf(__state[i]);
                    __state[i].weight = 1;
                }
            }
        }
        static void Finalizer(SO_RandomDropper __instance, RandomItem[] __state)
        {
            if (__state != null)
                __instance.randomizer.items = __state;
        }
    }

    [HarmonyPatch(typeof(Reciever), "Update")]
    static class Patch_RecieverOn
    {
        static Dictionary<Reciever, bool> wasOn = new Dictionary<Reciever, bool>();
        static void Postfix(Reciever __instance)
        {
            wasOn.TryGetValue(__instance, out var r);
            if (__instance.battery.On != r)
            {
                if (__instance.battery.On)
                    __instance.StartCoroutine(TurnOffTimer(__instance));
                wasOn[__instance] = !r;
            }
        }

        static IEnumerator TurnOffTimer(Reciever reciever)
        {
            var time = 0f;
            while (reciever.battery.On && Main.instance.autoOff >= 0 && Main.instance.autoOff > time)
            {
                yield return null;
                time += Time.deltaTime;
            }
            if (reciever.battery.On && Main.instance.autoOff >= 0)
                reciever.battery.On = false;
            yield break;
        }
    }

    [HarmonyPatch(typeof(VendingMachine_Element))]
    static class Patch_VendingMachine
    {
        [HarmonyPatch("HasInteractRequirement")]
        static void Postfix(ref bool __result)
        {
            if (Main.instance.freeVending)
                __result = true;
        }
        [HarmonyPatch("ConsumeRequiredItems")]
        static bool Prefix() => !Main.instance.freeVending;
    }

    [HarmonyPatch(typeof(Landmark), "GenerateTreasures")]
    static class Patch_GenerateLandmarkTreasures
    {
        static void Prefix(Landmark __instance, ref (int, int)? __state)
        {
            if (Main.instance.metalTreasure != 1 && __instance?.treasureLootSetting?.numberOfTreasures != null)
            {
                __state = (__instance.treasureLootSetting.numberOfTreasures.minValue, __instance.treasureLootSetting.numberOfTreasures.maxValue);
                __instance.treasureLootSetting.numberOfTreasures.minValue = Mathf.RoundToInt(__instance.treasureLootSetting.numberOfTreasures.minValue * Main.instance.metalTreasure);
                __instance.treasureLootSetting.numberOfTreasures.maxValue = Mathf.RoundToInt(__instance.treasureLootSetting.numberOfTreasures.maxValue * Main.instance.metalTreasure);
            }
        }
        static void Postfix(Landmark __instance, (int, int)? __state)
        {
            if (__state != null)
                (__instance.treasureLootSetting.numberOfTreasures.minValue, __instance.treasureLootSetting.numberOfTreasures.maxValue) = __state.Value;
        }
    }

    [HarmonyPatch(typeof(ArrayRandomizer), "GenerateRandom", typeof(int), typeof(int), typeof(int))]
    static class Patch_Randomizer
    {
        static void Prefix(ref int count, int min, int max)
        {
            if (count > (max - min))
                count = max - min;
        }
    }

    [HarmonyPatch(typeof(Seagull), "PlayerIsWithinVicinity")]
    static class Patch_SeagullCheckForPlayer
    {
        static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions)
        {
            var code = instructions.ToList();
            code.Insert(code.FindIndex(x => x.opcode == OpCodes.Ldarg_2) + 1, new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(Patch_SeagullCheckForPlayer), nameof(ModifyRadius))));
            return code;
        }
        static float ModifyRadius(float original) => original * Main.instance.seagullAware;
    }

    [HarmonyPatch(typeof(PickupChanneling), "ProgressChannel")]
    static class Patch_ProgressPickup
    {
        static void Prefix(PickupChanneling __instance, ref float time)
        {
            if (Main.instance.lootTime != 1 && __instance.GetComponentInParent<Network_Entity>())
                time = Main.instance.lootTime == 0 ? float.PositiveInfinity : (time / Main.instance.lootTime);
        }
    }

    [HarmonyPatch(typeof(LiquidFuelManager), "GetFilteredFuelValueSoFromItem")]
    static class Patch_FuelValue
    {
        static SO_FuelValue v;
        static SO_FuelValue value
        {
            get
            {
                if (!v)
                {
                    v = ScriptableObject.CreateInstance<SO_FuelValue>();
                    v.fuelFiltrationType = FuelValue_FiltrationType.FV_COMPOSTHONEYTANK;
                    v.itemType = ItemManager.GetItemByIndex(294);
                    v.fuelValueOfType = 1;
                }
                return v;
            }
        }
        static void Postfix(Item_Base item, FuelValue_FiltrationType fVFilterType, ref SO_FuelValue __result)
        {
            if (Main.instance.refineComb && item?.UniqueIndex == 294 && fVFilterType == FuelValue_FiltrationType.FV_COMPOSTHONEYTANK)
                __result = value;
        }
    }

    [HarmonyPatch(typeof(DeathMenu), "MenuOpen")]
    static class Patch_OpenDeathMenu
    {
        static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions)
        {
            var code = instructions.ToList();
            code.Insert(code.FindIndex(x => x.opcode == OpCodes.Ldfld && (x.operand as FieldInfo).Name == "canSurrender") + 1, new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(Patch_OpenDeathMenu), nameof(OverrideCanSurrender))));
            return code;
        }
        static bool OverrideCanSurrender(bool original) => original || Main.instance.hardRespawn;
    }

    [HarmonyPatch(typeof(MotorWheel), MethodType.Getter)]
    static class Patch_Motor
    {
        [HarmonyPatch("MotorStrength")]
        [HarmonyPostfix]
        static void MotorStrength(ref int __result) => __result = Mathf.RoundToInt(__result * Main.instance.enginePower);

        [HarmonyPatch("ExtraMotorStrength")]
        [HarmonyPostfix]
        static void ExtraMotorStrength(ref int __result) => __result = Mathf.RoundToInt(__result * Main.instance.enginePower);
    }

    [HarmonyPatch(typeof(ComputerChallenge), "StartTimer")]
    static class Patch_StartComputerChallengeTimer
    {
        static void Postfix(ref float ___timer)
        {
            ___timer = Mathf.RoundToInt(___timer * Main.instance.puzzleTime);
        }
    }

    [HarmonyPatch]
    static class Patch_ThrowThrowable
    {
        static int ProjectileLayer
        {
            get
            {
                var layer = 0;
                for (int i = 0; i < 32; i++)
                    if (!Physics.GetIgnoreLayerCollision(i, 22))
                        layer |= 1 << i;
                return layer;
            }
        }
        static MethodBase TargetMethod() => typeof(Raft).Assembly.GetTypes().First(x => x.Name.StartsWith("<StartThrow>")).GetMethod("MoveNext", ~BindingFlags.Default);
        static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions, MethodBase original)
        {
            var code = instructions.ToList();
            for (int i = 0; i < code.Count; i++)
                if (code[i].opcode == OpCodes.Stloc_2)
                {
                    code.InsertRange(i, new[] {
                        new CodeInstruction(OpCodes.Ldloc_1),
                        new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(Patch_ThrowThrowable), nameof(OverrideThrowForce)))
                    });
                    i += 2;
                }
                else if (code[i].opcode == OpCodes.Callvirt && (code[i].operand as MethodInfo).Name == "get_position")
                    code.InsertRange(i + 1, new[] {
                        new CodeInstruction(OpCodes.Ldloc_1),
                        new CodeInstruction(OpCodes.Ldloc_2),
                        new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(Patch_ThrowThrowable), nameof(OverrideLaunchPosition)))
                    });
            return code;
        }
        static Vector3 OverrideThrowForce(Vector3 original, ThrowableComponent throwable)
        {
            if (Main.instance.sniperRange)
                return throwable.playerNetwork.Camera.transform.forward * original.magnitude;
            return original;
        }
        static Vector3 OverrideLaunchPosition(Vector3 original, ThrowableComponent throwable, Vector3 launchForce)
        {
            if (Main.instance.sniperRange && Physics.Raycast(original, launchForce, out var hit, 1000, ProjectileLayer, QueryTriggerInteraction.Ignore))
                return hit.point - launchForce.normalized * 0.2f;
            return original;
        }
    }

    [HarmonyPatch(typeof(CharacterModelModifications), "Update")]
    static class Patch_FOVUpdate
    {
        static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions)
        {
            var code = instructions.ToList();
            for (int i = 0; i < code.Count; i++)
                if (code[i].opcode == OpCodes.Callvirt && (code[i].operand as MethodInfo).Name == "get_value")
                    code.Insert(i + 1, new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(Patch_FOVUpdate), nameof(OverrideFOV))));
            return code;
        }
        static float OverrideFOV(float original)
        {
            if (Main.instance.ExtraSettingsAPI_Loaded && CanvasHelper.ActiveMenu == MenuType.None && MyInput.GetButton(Main.instance.zoomKey))
                return Main.instance.zoomFOV;
            return original;
        }
    }

    [HarmonyPatch(typeof(RConsole), "HandleUnityLog")]
    static class Patch_ConsoleHandleLog
    {
        static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions)
        {
            var code = instructions.ToList();
            code.Insert(code.FindIndex(x => x.opcode == OpCodes.Ldc_I4_S) + 1, new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(Patch_ConsoleHandleLog), nameof(OverrideConsoleLines))));
            return code;
        }
        static int OverrideConsoleLines(int original)
        {
            if (Main.instance.consoleLines >= 0)
                return Main.instance.consoleLines + 1;
            return original;
        }
    }

    [HarmonyPatch(typeof(Bobber))]
    static class Patch_Bobber
    {
        [HarmonyPatch("FishOnHook")]
        [HarmonyPrefix]
        static void FishOnHook(ref float timeDelay) => timeDelay *= Main.instance.fishingWait;

        [HarmonyPatch("FishEscaped")]
        [HarmonyPrefix]
        static void FishEscaped(ref float timeDelay) => timeDelay *= Main.instance.fishingWindow;
    }

    [HarmonyPatch]
    static class Patch_PickingUp
    {
        public static bool calling = false;

        [HarmonyPatch(typeof(Pickup), "AddItemToInventory")]
        [HarmonyPrefix]
        static void Prefix_AddItemToInventory(PickupItem item)
        {
            if (!item.GetComponent<DropItem>())
            {
                calling = Main.instance.itemLooting != 1;
                if (Main.instance.itemLooting != 1 && item.itemInstance != null && item.itemInstance.Valid)
                    item.itemInstance.Amount *= Mathf.RoundToInt(item.itemInstance.Amount * Main.instance.itemLooting);
            }
        }

        [HarmonyPatch(typeof(Pickup), "AddItemToInventory")]
        [HarmonyPostfix]
        static void Postfix_AddItemToInventory() => calling = false;

        [HarmonyPatch(typeof(HarvestableTree), "Harvest")]
        [HarmonyPrefix]
        static void Prefix_Harvest() => calling = Main.instance.itemLooting != 1;

        [HarmonyPatch(typeof(HarvestableTree), "Harvest")]
        [HarmonyPostfix]
        static void Postfix_Harvest() => calling = false;
    }

    [HarmonyPatch(typeof(PlayerInventory), "AddItem")]
    static class Patch_AddItemToPlayer
    {
        [HarmonyPatch(new[] { typeof(string), typeof(int) })]
        static void Prefix(ref int amount)
        {
            if (Patch_PickingUp.calling)
                amount = Mathf.RoundToInt(amount * Main.instance.itemLooting);
        }
    }

    [HarmonyPatch]
    static class Patch_Respawn {
        [HarmonyPatch(typeof(Player), "StartRespawn")]
        [HarmonyPrefix]
        static void StartRespawn(ref bool clearInventory)
        {
            if (Main.instance.keepInventory)
                clearInventory = false;
        }

        [HarmonyPatch(typeof(Player), "RespawnWithoutBed")]
        [HarmonyPrefix]
        static void RespawnWithoutBed(ref bool clearInventory)
        {
            if (Main.instance.keepInventory)
                clearInventory = false;
        }
    }

    [HarmonyPatch(typeof(Reciever_Antenna), "HasValidConnection", MethodType.Getter)]
    static class Patch_AntennaValid
    {
        static void Postfix(Reciever_Antenna __instance, ref bool __result)
        {
            if (Main.instance.antennaAnywhere)
                __result = __instance.ConnectedToReciever;
        }
    }
    [HarmonyPatch(typeof(Reciever), "HasCorrectAltitude", MethodType.Getter)]
    static class Patch_RecieverValid
    {
        static void Postfix(Reciever __instance, ref bool __result)
        {
            if (Main.instance.recieverAnywhere)
                __result = true;
        }
    }

    [HarmonyPatch(typeof(Item_Base),"MaxUses",MethodType.Getter)]
    static class Patch_ItemMaxUses
    {
        static void Postfix(Item_Base __instance, ref int __result)
        {
            if (__result > 1)
            {
                if (__instance.UniqueName.StartsWith("Battery"))
                    __result = Mathf.RoundToInt(__result * Main.instance.batteryMax);
                else if (__instance.settings_consumeable?.FoodType > FoodType.None)
                    __result = Mathf.RoundToInt(__result * Main.instance.foodMax);
                else if (__instance.settings_equipment?.EquipType > EquipSlotType.None)
                    __result = Mathf.RoundToInt(__result * Main.instance.equipmentMax);
                else
                    __result = Mathf.RoundToInt(__result * Main.instance.toolMax);
                if (__result < 1)
                    __result = 1;
            }
        }
    }

    [HarmonyPatch(typeof(ItemCollector),"OnTriggerEnter")]
    static class Patch_ItemCollectorMax
    {
        static void Prefix(ref int ___maxNumberOfItems, ref int? __state)
        {
            if (Main.instance.collectorMax != 1)
            {
                __state = ___maxNumberOfItems;
                ___maxNumberOfItems = Mathf.RoundToInt(___maxNumberOfItems * Main.instance.collectorMax);
            }
        }
        static void Postfix(ref int ___maxNumberOfItems, int? __state)
        {
            if (__state != null)
                ___maxNumberOfItems = __state.Value;
        }
    }

    [HarmonyPatch(typeof(CookingSlot))]
    static class Patch_CookingSlot
    {
        const int metalOre = 19;
        const int bolt = 154;
        const int hinge = 155;
        static bool dontSkip = true;
        [HarmonyPatch("CanCookItem")]
        [HarmonyPostfix]
        static void CanCookItem(CookingSlot __instance, Item_Base itemToCheck, ref bool __result)
        {
            if (Main.instance.recycleMetal && dontSkip && !__result && (itemToCheck?.UniqueIndex == bolt || itemToCheck?.UniqueIndex == hinge)) {
                dontSkip = false;
                __result = __instance.CanCookItem(ItemManager.GetItemByIndex(metalOre));
                dontSkip = true;
            }
        }

        [HarmonyPatch("StartCooking")]
        [HarmonyPrefix]
        static void StartCooking(CookingSlot __instance, ref Item_Base cookableItem)
        {
            if (Main.instance.recycleMetal && (cookableItem?.UniqueIndex == bolt || cookableItem?.UniqueIndex == hinge))
            {
                var metal = ItemManager.GetItemByIndex(metalOre);
                dontSkip = false;
                try
                {
                    if (!__instance.CanCookItem(cookableItem) && __instance.CanCookItem(metal))
                        cookableItem = metal;
                } catch { }
                dontSkip = true;
            }
        }
    }

    [HarmonyPatch(typeof(Sprinkler), "WaterNearbyPlots")]
    static class Patch_SprinklerRange
    {
        static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions)
        {
            var code = instructions.ToList();
            code.Insert(code.FindLastIndex(code.FindIndex(x => (x.operand as MethodInfo)?.Name == nameof(Physics.OverlapSphere)), x => x.opcode == OpCodes.Ldc_R4) + 1, new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(Patch_SprinklerRange), nameof(SprinklerRadius))));
            code.Insert(code.FindIndex(code.FindIndex(x => (x.operand as MethodInfo)?.Name == nameof(Mathf.Abs)), x => x.opcode == OpCodes.Ldc_R4) + 1, new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(Patch_SprinklerRange), nameof(SprinklerDistance))));
            return code;
        }

        static float SprinklerRadius(float original)
        {
            if (Main.instance.sprinklerRadius != 1)
                return original * Main.instance.sprinklerRadius;
            return original;
        }
        static float SprinklerDistance(float original)
        {
            if (Main.instance.sprinklerDistance != 1)
                return original * Main.instance.sprinklerDistance;
            return original;
        }
    }

    static class ExtentionMethods
    {
        public static void CopyFieldsOf(this object value, object source)
        {
            var t1 = value.GetType();
            var t2 = source.GetType();
            while (!t1.IsAssignableFrom(t2))
                t1 = t1.BaseType;
            while (t1 != typeof(Object) && t1 != typeof(object))
            {
                foreach (var f in t1.GetFields(~BindingFlags.Default))
                    if (!f.IsStatic)
                        f.SetValue(value, f.GetValue(source));
                t1 = t1.BaseType;
            }
        }
        public static float ParseFloat(this string value, float EmptyFallback = 1)
        {
            if (string.IsNullOrWhiteSpace(value))
                return EmptyFallback;
            if (value.Contains(",") && !value.Contains("."))
                value = value.Replace(',', '.');
            var c = CultureInfo.CurrentCulture;
            CultureInfo.CurrentCulture = CultureInfo.GetCultureInfoByIetfLanguageTag("en-NZ");
            Exception e = null;
            float r = 0;
            try
            {
                r = float.Parse(value);
            }
            catch (Exception e2)
            {
                e = e2;
            }
            CultureInfo.CurrentCulture = c;
            if (e != null)
                throw e;
            return r;
        }
        public static int ParseInt(this string value, int EmptyFallback = 1)
        {
            if (string.IsNullOrWhiteSpace(value))
                return EmptyFallback;
            if (value.Contains(",") && !value.Contains("."))
                value = value.Replace(',', '.');
            var c = CultureInfo.CurrentCulture;
            CultureInfo.CurrentCulture = CultureInfo.GetCultureInfoByIetfLanguageTag("en-NZ");
            Exception e = null;
            int r = 0;
            try
            {
                r = int.Parse(value);
            }
            catch (Exception e2)
            {
                e = e2;
            }
            CultureInfo.CurrentCulture = c;
            if (e != null)
                throw e;
            return r;
        }
    }
}